package dev.shadowsoffire.apotheosis.spawn.spawner;

import net.minecraft.util.random.WeightedEntry;
import net.minecraft.world.entity.SpawnPlacements;
import net.minecraft.world.level.LightLayer;
import net.minecraft.world.Difficulty;
import net.minecraft.world.level.LevelReader;
import net.minecraft.world.level.LevelAccessor;
import net.minecraftforge.eventbus.api.Event;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.event.entity.living.MobSpawnEvent;
import java.util.stream.Stream;
import net.minecraft.world.entity.Entity;
import net.minecraft.nbt.ListTag;
import net.minecraft.world.entity.SpawnGroupData;
import net.minecraftforge.event.ForgeEventFactory;
import net.minecraft.world.entity.MobSpawnType;
import net.minecraft.world.phys.AABB;
import java.util.function.Function;
import java.util.function.Predicate;
import java.util.Objects;
import net.minecraft.world.entity.Mob;
import net.minecraft.world.level.ServerLevelAccessor;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.core.particles.ParticleOptions;
import net.minecraft.core.particles.ParticleTypes;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraft.world.level.block.Blocks;
import net.minecraft.util.random.SimpleWeightedRandomList;
import net.minecraft.world.level.SpawnData;
import net.minecraft.util.RandomSource;
import javax.annotation.Nullable;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.level.BaseSpawner;
import net.minecraft.world.level.Level;
import net.minecraft.network.protocol.game.ClientboundBlockEntityDataPacket;
import net.minecraft.network.Connection;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.block.entity.SpawnerBlockEntity;

public class ApothSpawnerTile extends SpawnerBlockEntity
{
    public boolean ignoresPlayers;
    public boolean ignoresConditions;
    public boolean redstoneControl;
    public boolean ignoresLight;
    public boolean hasNoAI;
    public boolean silent;
    public boolean baby;
    
    public ApothSpawnerTile(final BlockPos pos, final BlockState state) {
        super(pos, state);
        this.ignoresPlayers = false;
        this.ignoresConditions = false;
        this.redstoneControl = false;
        this.ignoresLight = false;
        this.hasNoAI = false;
        this.silent = false;
        this.baby = false;
        this.f_59788_ = new SpawnerLogicExt();
    }
    
    public void m_183515_(final CompoundTag tag) {
        tag.m_128379_("ignore_players", this.ignoresPlayers);
        tag.m_128379_("ignore_conditions", this.ignoresConditions);
        tag.m_128379_("redstone_control", this.redstoneControl);
        tag.m_128379_("ignore_light", this.ignoresLight);
        tag.m_128379_("no_ai", this.hasNoAI);
        tag.m_128379_("silent", this.silent);
        tag.m_128379_("baby", this.baby);
        super.m_183515_(tag);
    }
    
    public void m_142466_(final CompoundTag tag) {
        this.ignoresPlayers = tag.m_128471_("ignore_players");
        this.ignoresConditions = tag.m_128471_("ignore_conditions");
        this.redstoneControl = tag.m_128471_("redstone_control");
        this.ignoresLight = tag.m_128471_("ignore_light");
        this.hasNoAI = tag.m_128471_("no_ai");
        this.silent = tag.m_128471_("silent");
        this.baby = tag.m_128471_("baby");
        super.m_142466_(tag);
    }
    
    public void onDataPacket(final Connection net, final ClientboundBlockEntityDataPacket pkt) {
        this.m_142466_(pkt.m_131708_());
    }
    
    public class SpawnerLogicExt extends BaseSpawner
    {
        public void m_253197_(final EntityType<?> type, @Nullable final Level level, final RandomSource rand, final BlockPos pos) {
            this.f_45444_ = new SpawnData();
            super.m_253197_((EntityType)type, level, rand, pos);
            this.f_45443_ = SimpleWeightedRandomList.m_185862_((Object)this.f_45444_);
            if (level != null) {
                this.m_151350_(level, pos);
            }
        }
        
        public void m_142523_(final Level level, final BlockPos pos, final int id) {
            level.m_7696_(pos, Blocks.f_50085_, id, 0);
        }
        
        public void m_142667_(final Level level, final BlockPos pos, final SpawnData nextSpawnData) {
            super.m_142667_(level, pos, nextSpawnData);
            if (level != null) {
                final BlockState state = level.m_8055_(pos);
                level.m_7260_(pos, state, state, 4);
            }
        }
        
        @Nullable
        public BlockEntity getSpawnerBlockEntity() {
            return (BlockEntity)ApothSpawnerTile.this;
        }
        
        protected boolean isActivated(final Level level, final BlockPos pos) {
            final boolean hasPlayer = ApothSpawnerTile.this.ignoresPlayers || this.m_151343_(level, pos);
            return hasPlayer && (!ApothSpawnerTile.this.redstoneControl || ApothSpawnerTile.this.f_58857_.m_276867_(pos));
        }
        
        private void m_151350_(final Level pLevel, final BlockPos pPos) {
            if (this.f_45448_ <= this.f_45447_) {
                this.f_45442_ = this.f_45447_;
            }
            else {
                this.f_45442_ = this.f_45447_ + pLevel.f_46441_.m_188503_(this.f_45448_ - this.f_45447_);
            }
            this.f_45443_.m_216829_(pLevel.f_46441_).ifPresent(potential -> this.m_142667_(pLevel, pPos, (SpawnData)potential.m_146310_()));
            this.m_142523_(pLevel, pPos, 1);
        }
        
        public void m_151319_(final Level pLevel, final BlockPos pPos) {
            if (!this.isActivated(pLevel, pPos)) {
                this.f_45446_ = this.f_45445_;
            }
            else {
                final double d0 = pPos.m_123341_() + pLevel.f_46441_.m_188500_();
                final double d2 = pPos.m_123342_() + pLevel.f_46441_.m_188500_();
                final double d3 = pPos.m_123343_() + pLevel.f_46441_.m_188500_();
                pLevel.m_7106_((ParticleOptions)ParticleTypes.f_123762_, d0, d2, d3, 0.0, 0.0, 0.0);
                pLevel.m_7106_((ParticleOptions)ParticleTypes.f_123744_, d0, d2, d3, 0.0, 0.0, 0.0);
                if (this.f_45442_ > 0) {
                    --this.f_45442_;
                }
                this.f_45446_ = this.f_45445_;
                this.f_45445_ = (this.f_45445_ + 1000.0f / (this.f_45442_ + 200.0f)) % 360.0;
            }
        }
        
        public void m_151311_(final ServerLevel level, final BlockPos pPos) {
            if (this.isActivated((Level)level, pPos)) {
                if (this.f_45442_ == -1) {
                    this.m_151350_((Level)level, pPos);
                }
                if (this.f_45442_ > 0) {
                    --this.f_45442_;
                }
                else {
                    boolean flag = false;
                    final RandomSource rand = level.m_213780_();
                    final SpawnData spawnData = this.m_253144_((Level)level, rand, pPos);
                    for (int i = 0; i < this.f_45449_; ++i) {
                        final CompoundTag tag = spawnData.m_186567_();
                        final EntityType<?> entityType = (EntityType<?>)EntityType.m_20637_(tag).orElse(null);
                        if (entityType == null) {
                            this.m_151350_((Level)level, pPos);
                            return;
                        }
                        final ListTag posList = tag.m_128437_("Pos", 6);
                        final int size = posList.size();
                        final double x = (size >= 1) ? posList.m_128772_(0) : (pPos.m_123341_() + (rand.m_188500_() - rand.m_188500_()) * this.f_45453_ + 0.5);
                        final double y = (size >= 2) ? posList.m_128772_(1) : (pPos.m_123342_() + rand.m_188503_(3) - 1);
                        final double z = (size >= 3) ? posList.m_128772_(2) : (pPos.m_123343_() + (rand.m_188500_() - rand.m_188500_()) * this.f_45453_ + 0.5);
                        if (level.m_45772_(entityType.m_20585_(x, y, z))) {
                            final BlockPos blockpos = BlockPos.m_274561_(x, y, z);
                            final LyingLevel liar = new LyingLevel(level);
                            boolean useLiar = false;
                            if (!ApothSpawnerTile.this.ignoresConditions) {
                                if (ApothSpawnerTile.this.ignoresLight) {
                                    boolean pass = false;
                                    for (int light = 0; light < 16; ++light) {
                                        liar.setFakeLightLevel(light);
                                        if (this.checkSpawnRules(spawnData, entityType, (ServerLevelAccessor)liar, blockpos)) {
                                            pass = true;
                                            break;
                                        }
                                    }
                                    if (!pass) {
                                        continue;
                                    }
                                    useLiar = true;
                                }
                                else if (!this.checkSpawnRules(spawnData, entityType, (ServerLevelAccessor)level, blockpos)) {
                                    continue;
                                }
                            }
                            final Entity entity = EntityType.m_20645_(tag, (Level)level, freshEntity -> {
                                freshEntity.m_7678_(x, y, z, freshEntity.m_146908_(), freshEntity.m_146909_());
                                return freshEntity;
                            });
                            if (entity == null) {
                                this.m_151350_((Level)level, pPos);
                                return;
                            }
                            if (ApothSpawnerTile.this.hasNoAI) {
                                final Stream 20199_ = entity.m_20199_();
                                final Class<Mob> obj = Mob.class;
                                Objects.requireNonNull(obj);
                                final Stream filter = 20199_.filter(obj::isInstance);
                                final Class<Mob> obj2 = Mob.class;
                                Objects.requireNonNull(obj2);
                                final Mob mob;
                                filter.map(obj2::cast).forEach(mob -> {
                                    mob.m_21557_((boolean)(1 != 0));
                                    mob.getPersistentData().m_128379_("apotheosis:movable", (boolean)(1 != 0));
                                    return;
                                });
                            }
                            if (ApothSpawnerTile.this.baby && entity instanceof Mob) {
                                final Mob mob = (Mob)entity;
                                mob.m_6863_(true);
                            }
                            if (ApothSpawnerTile.this.silent) {
                                entity.m_20225_(true);
                            }
                            final int nearby = level.m_45976_((Class)entity.getClass(), new AABB((double)pPos.m_123341_(), (double)pPos.m_123342_(), (double)pPos.m_123343_(), (double)(pPos.m_123341_() + 1), (double)(pPos.m_123342_() + 1), (double)(pPos.m_123343_() + 1)).m_82400_((double)this.f_45453_)).size();
                            if (nearby >= this.f_45451_) {
                                this.m_151350_((Level)level, pPos);
                                return;
                            }
                            entity.m_7678_(entity.m_20185_(), entity.m_20186_(), entity.m_20189_(), rand.m_188501_() * 360.0f, 0.0f);
                            if (entity instanceof final Mob mob2) {
                                if (!this.checkSpawnPositionSpawner(mob2, (ServerLevelAccessor)(useLiar ? liar : level), MobSpawnType.SPAWNER, spawnData, this)) {
                                    continue;
                                }
                                final MobSpawnEvent.FinalizeSpawn event = ForgeEventFactory.onFinalizeSpawnSpawner(mob2, (ServerLevelAccessor)(useLiar ? liar : level), level.m_6436_(entity.m_20183_()), (SpawnGroupData)null, tag, (BaseSpawner)this);
                                if (event != null && spawnData.m_186567_().m_128440_() == 1 && spawnData.m_186567_().m_128425_("id", 8)) {
                                    ((Mob)entity).m_6518_((ServerLevelAccessor)(useLiar ? liar : level), event.getDifficulty(), event.getSpawnType(), event.getSpawnData(), event.getSpawnTag());
                                }
                            }
                            if (!level.m_8860_(entity)) {
                                this.m_151350_((Level)level, pPos);
                                return;
                            }
                            level.m_46796_(2004, pPos, 0);
                            if (entity instanceof final Mob mob3) {
                                mob3.m_21373_();
                            }
                            flag = true;
                        }
                    }
                    if (flag) {
                        this.m_151350_((Level)level, pPos);
                    }
                }
            }
        }
        
        public boolean checkSpawnPositionSpawner(final Mob mob, final ServerLevelAccessor level, final MobSpawnType spawnType, final SpawnData spawnData, final BaseSpawner spawner) {
            final MobSpawnEvent.PositionCheck event = new MobSpawnEvent.PositionCheck(mob, level, spawnType, (BaseSpawner)null);
            MinecraftForge.EVENT_BUS.post((Event)event);
            if (event.getResult() == Event.Result.DEFAULT) {
                return ApothSpawnerTile.this.ignoresConditions || spawnData.m_186574_().isPresent() || (mob.m_5545_((LevelAccessor)level, MobSpawnType.SPAWNER) && mob.m_6914_((LevelReader)level));
            }
            return event.getResult() == Event.Result.ALLOW;
        }
        
        private boolean checkSpawnRules(final SpawnData spawnData, final EntityType<?> entityType, final ServerLevelAccessor pServerLevel, final BlockPos blockpos) {
            if (spawnData.m_186574_().isPresent()) {
                if (!entityType.m_20674_().m_21609_() && pServerLevel.m_46791_() == Difficulty.PEACEFUL) {
                    return false;
                }
                final SpawnData.CustomSpawnRules customRules = spawnData.m_186574_().get();
                if (ApothSpawnerTile.this.ignoresLight) {
                    return true;
                }
                if (!customRules.f_186584_().m_184578_((Comparable)pServerLevel.m_45517_(LightLayer.BLOCK, blockpos)) || !customRules.f_186585_().m_184578_((Comparable)pServerLevel.m_45517_(LightLayer.SKY, blockpos))) {
                    return false;
                }
            }
            else if (!SpawnPlacements.m_217074_((EntityType)entityType, pServerLevel, MobSpawnType.SPAWNER, blockpos, pServerLevel.m_213780_())) {
                return false;
            }
            return true;
        }
    }
}
